import { CachePlugin } from "./cache-factory";
declare type CacheEntry = {
    value: unknown;
    expire: number | null;
};
declare class MemoryCache implements CachePlugin {
    constructor();
    cache: {
        [key: string]: CacheEntry;
    };
    get<T>(key: string): Promise<T | null>;
    set(key: string, value: unknown, ms?: number): Promise<void>;
    invalidate(): void;
    private isExpired;
}
export { MemoryCache, };
