"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const request_1 = __importDefault(require("request"));
const tRequest = request_1.default.Request;
class WardenWrappedRequest {
    constructor(configuration) {
        if (configuration.name && WardenWrappedRequest.requestManager.isRouteRegistered(configuration.name)) {
            const requestOptions = Object.assign({ headers: {} }, configuration);
            delete requestOptions.callback;
            delete requestOptions.name;
            WardenWrappedRequest.requestManager.handle(configuration.name, requestOptions, configuration.callback);
        }
        else {
            return new tRequest(configuration);
        }
    }
}
exports.WardenWrappedRequest = WardenWrappedRequest;
class RequestWrapper {
    constructor() {
        this.request = request_1.default;
    }
    config(options) {
        this.request = request_1.default.defaults(options);
    }
    wrap(requestManager) {
        WardenWrappedRequest.requestManager = requestManager;
        if (!request_1.default.Request.requestManager) {
            request_1.default.Request = WardenWrappedRequest;
        }
    }
}
exports.RequestWrapper = RequestWrapper;
//# sourceMappingURL=request-wrapper.js.map