import request, { RequestCallback } from "request";
import { RequestOptions } from "./request-manager";
interface RequestChunk {
    id: number;
    key: string;
    requestOptions: RequestOptions;
    cb: RequestCallback;
}
interface ResponseChunk extends RequestChunk {
    response?: request.Response;
    error?: {
        code: string;
    };
}
declare type NextHandler = (chunk: ResponseChunk | RequestChunk) => void;
declare class Streamer {
    readonly name: string;
    nextStream?: Streamer;
    previousStream?: Streamer;
    constructor(name: string);
    connect(wardenStream: Streamer): Streamer;
    start(key: string, id: number, requestOptions: RequestOptions, cb: RequestCallback): void;
    respond<T extends ResponseChunk>(chunk: T): void;
    request<T extends RequestChunk>(chunk: T): void;
    protected onRequest(chunk: RequestChunk, next?: NextHandler): void;
    protected onResponse(chunk: ResponseChunk, next?: NextHandler): void;
    private _onRequest;
    private _onResponse;
}
export { NextHandler, Streamer, RequestChunk, ResponseChunk };
